#include "messageservicetest.h"
#include "../services/messageservice.h"

void MessageServiceTest::parseTextMessage()
{
    QString msg( "{\"msg\":\"changed\",\"collection\":\"stream-room-messages\",\"id\":\"id\",\"fields\":{\"eventName\":\"Bj8MoEojximnoZtNf\",\"args\":[{\"_id\":\"WQ3JgwTavRC9AJ2r5\",\"rid\":\"Bj8MoEojximnoZtNf\",\"msg\":\"test\",\"ts\":{\"$date\":1524554832724},\"u\":{\"_id\":\"2kzae6pwXf2Dz9myN\",\"username\":\"armin.felder\",\"name\":\"Armin Felder\"},\"mentions\":[],\"channels\":[],\"_updatedAt\":{\"$date\":1524554832730}}]}}" );
    MessageService service( nullptr, nullptr, nullptr, nullptr );
    QJsonDocument doc( msg );
    QJsonObject msgObj = doc.object();
    auto parsed = service.parseMessage( msgObj );
    Q_VERIFY( parsed->getMessageString() == "test" && parsed->getTimestamp() == 1524554832724 && parsed->getAuthor() == "armin.felder" && parsed->getAuthorId() == "2kzae6pwXf2Dz9myN" &&
              parsed->getId() == "WQ3JgwTavRC9AJ2r5" && parsed->getMessageType() == "textMessage" && parsed->getRoomId() == "Bj8MoEojximnoZtNf" && parsed->getOwnMessage() == true );
}
