#include "utilstest.h"
#include "../utils.h"
#include "../repos/emojirepo.h"
#include "../repos/entities/emoji.h"
#include <QSharedPointer>
void TestUtils::cleanUnicodeEmojies()
{
    QString emojiString( "some \u263A string" );
    QString result = Utils::removeUtf8Emojis( emojiString );
    qDebug() << result;
    QVERIFY( result == "some  string" );
}

void TestUtils::emojify()
{
    QString emojiString( "some :test: !" );
    EmojiRepo emojiRepo;
    QSharedPointer<Emoji> emoji = QSharedPointer<Emoji>( new Emoji( "test", "png", "testCategory" ) );
    emoji->setHtml( "<img src='img.png'>" );
    emoji->setUnicodeChar( "\u263A" );
    emojiRepo.add( QSharedPointer<Emoji>( emoji ) );
    QString result = Utils::emojiFy( emojiString, &emojiRepo );
    QVERIFY( result == "some <img src='img.png'> !" );
}

void TestUtils::linkify()
{
    QString testString( "got to http://www.google.com or www.google.com" );
    QString result = Utils::linkiFy( testString );
    QVERIFY( result == "got to <a href='http://www.google.com'>http://www.google.com</a> or <a href='http://www.google.com'>www.google.com</a>" );
}
